diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_tunnel.c freeswan-1.9/klips/net/ipsec/ipsec_tunnel.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_tunnel.c	Mon Feb 26 19:51:00 2001
+++ freeswan-1.9/klips/net/ipsec/ipsec_tunnel.c	Tue Jun 12 16:35:03 2001
@@ -2510,8 +2996,104 @@
 
 /*
  * $Log: ipsec_tunnel.c,v $
- * Revision 1.137.2.1  2001/02/27 00:51:00  henry
- * message improvements
+ * Revision 1.163  2001/06/06 20:28:51  rgb
+ * Added sanity checks for NULL skbs and devices.
+ * Added more debugging output to various functions.
+ * Removed redundant dev->priv argument to ipsec_tunnel_{at,de}tach().
+ * Renamed ipsec_tunnel_attach() virtual and physical device arguments.
+ * Corrected neigh_setup() device function assignment.
+ * Keep valid pointers to ipsec_tunnel_*() on detach.
+ * Set dev->type to the originally-initiallised value.
+ *
+ * Revision 1.162  2001/06/01 07:28:04  rgb
+ * Added sanity checks for detached devices.  Don't down virtual devices
+ * to prevent packets going out in the clear if the detached device comes
+ * back up.
+ *
+ * Revision 1.161  2001/05/30 08:14:52  rgb
+ * Removed vestiges of esp-null transforms.
+ * NetDev Notifier instrumentation to track down disappearing devices.
+ *
+ * Revision 1.160  2001/05/29 05:15:12  rgb
+ * Added SS' PMTU patch which notifies sender if packet doesn't fit
+ * physical MTU (if it wasn't ICMP) and then drops it.
+ *
+ * Revision 1.159  2001/05/27 06:12:12  rgb
+ * Added structures for pid, packet count and last access time to eroute.
+ * Added packet count to beginning of /proc/net/ipsec_eroute.
+ *
+ * Revision 1.158  2001/05/24 05:39:33  rgb
+ * Applied source zeroing to 2.2 ip_route_output() call as well to enable
+ * PASS eroutes for opportunism.
+ *
+ * Revision 1.157  2001/05/23 22:35:28  rgb
+ * 2.4 source override simplification.
+ *
+ * Revision 1.156  2001/05/23 21:41:31  rgb
+ * Added error return code printing on ip_route_output().
+ *
+ * Revision 1.155  2001/05/23 05:09:13  rgb
+ * Fixed incorrect ip_route_output() failure message.
+ *
+ * Revision 1.154  2001/05/21 14:53:31  rgb
+ * Added debug statement for case when ip_route_output() fails, causing
+ * packet to be dropped, but log looked ok.
+ *
+ * Revision 1.153  2001/05/19 02:37:54  rgb
+ * Fixed missing comment termination.
+ *
+ * Revision 1.152  2001/05/19 02:35:50  rgb
+ * Debug code optimisation for non-debug speed.
+ * Kernel version compiler define comments.
+ * 2.2 and 2.4 kernel ip_send device and ip debug output added.
+ *
+ * Revision 1.151  2001/05/18 16:17:35  rgb
+ * Changed reference from "magic" to "shunt" SAs.
+ *
+ * Revision 1.150  2001/05/18 16:12:19  rgb
+ * Changed UDP/500 bypass test from 3 nested ifs to one anded if.
+ *
+ * Revision 1.149  2001/05/16 04:39:33  rgb
+ * Add default == eroute.dest to IKE bypass conditions for magic eroutes.
+ *
+ * Revision 1.148  2001/05/05 03:31:41  rgb
+ * IP frag debugging updates and enhancements.
+ *
+ * Revision 1.147  2001/05/03 19:41:40  rgb
+ * Added SS' skb_cow fix for 2.4.4.
+ *
+ * Revision 1.146  2001/04/30 19:28:16  rgb
+ * Update for 2.4.4.  ip_select_ident() now has 3 args.
+ *
+ * Revision 1.145  2001/04/23 14:56:10  rgb
+ * Added spin_lock() check to prevent double-locking for multiple
+ * transforms and hence kernel lock-ups with SMP kernels.
+ *
+ * Revision 1.144  2001/04/21 23:04:45  rgb
+ * Define out skb->used for 2.4 kernels.
+ * Check if soft expire has already been sent before sending another to
+ * prevent ACQUIRE flooding.
+ *
+ * Revision 1.143  2001/03/16 07:37:21  rgb
+ * Added comments to all #endifs.
+ *
+ * Revision 1.142  2001/02/28 05:03:27  rgb
+ * Clean up and rationalise startup messages.
+ *
+ * Revision 1.141  2001/02/27 22:24:54  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
+ * Revision 1.140  2001/02/27 06:40:12  rgb
+ * Fixed TRAP->HOLD eroute byte order.
+ *
+ * Revision 1.139  2001/02/26 20:38:59  rgb
+ * Added compiler defines for 2.4.x-specific code.
+ *
+ * Revision 1.138  2001/02/26 19:57:27  rgb
+ * Implement magic SAs %drop, %reject, %trap, %hold, %pass as part
+ * of the new SPD and to support opportunistic.
+ * Drop sysctl_ipsec_{no_eroute_pass,opportunistic}, replaced by magic SAs.
  *
  * Revision 1.137  2001/02/19 22:29:49  rgb
  * Fixes for presence of active ipv6 segments which share ipsec physical
@@ -2615,9 +3197,6 @@
  * Added a hard/soft expiry parameter to pfkey_expire(). (Momchil)
  * Re-arranged the order of soft and hard expiry to conform to RFC2367.
  * Clean up references to CONFIG_IPSEC_PFKEYv2.
- *
- * Revision 1.111  2000/08/01 14:51:51  rgb
- * Removed _all_ remaining traces of DES.
  *
  * Revision 1.110  2000/07/28 14:58:31  rgb
  * Changed kfree_s to kfree, eliminating extra arg to fix 2.4.0-test5.
diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_xform.c freeswan-1.9/klips/net/ipsec/ipsec_xform.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_xform.c	Sun Nov  5 23:32:08 2000
+++ freeswan-1.9/klips/net/ipsec/ipsec_xform.c	Tue Jun 12 16:07:52 2001
@@ -13,7 +13,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: ipsec_xform.c,v 1.47 2000/11/06 04:32:08 rgb Exp $
+ * RCSID $Id: ipsec_xform.c,v 1.51 2001/05/30 08:14:03 rgb Exp $
  */
 
 #include <linux/config.h>
@@ -61,7 +61,7 @@
 int debug_xform = 0;
 #endif /* CONFIG_IPSEC_DEBUG */
 
-#define SENDERR(_x) do { len = -(_x); goto errlab; } while (0)
+#define SENDERR(_x) do { error = -(_x); goto errlab; } while (0)
 
 extern int des_set_key(caddr_t, caddr_t);
 
@@ -69,6 +69,9 @@
 { XF_IP4,		0,		"IPv4_Encapsulation"},
 { XF_AHHMACMD5,		XFT_AUTH,	"HMAC_MD5_Authentication"},
 { XF_AHHMACSHA1,	XFT_AUTH,	"HMAC_SHA-1_Authentication"},
+{ XF_ESPDES,		XFT_CONF,	"DES_Encryption"},
+{ XF_ESPDESMD596,	XFT_CONF,	"DES-MD5-96_Encryption"},
+{ XF_ESPDESSHA196,	XFT_CONF,	"DES-SHA1-96_Encryption"},
 { XF_ESP3DES,		XFT_CONF,	"3DES_Encryption"},
 { XF_ESP3DESMD596,	XFT_CONF,	"3DES-MD5-96_Encryption"},
 { XF_ESP3DESSHA196,	XFT_CONF,	"3DES-SHA1-96_Encryption"},
@@ -101,25 +104,31 @@
 	int hashval;
 	struct tdb *tdbp;
         char sa[SATOA_BUF];
+	size_t sa_len;
 
 	if(!said) {
 		KLIPS_PRINT(debug_xform,
-			    "klips_error:gettdb: null pointer passed in!\n");
+			    "klips_error:gettdb: "
+			    "null pointer passed in!\n");
 		return NULL;
 	}
 
-	satoa(*said, 0, sa, SATOA_BUF);
+	sa_len = satoa(*said, 0, sa, SATOA_BUF);
 
 	hashval = (said->spi+said->dst.s_addr+said->proto) % TDB_HASHMOD;
 	
 	KLIPS_PRINT(debug_xform,
-		    "klips_debug:gettdb: linked entry in tdb table for hash=%d of SA:%s requested.\n",
-		    hashval, sa);
+		    "klips_debug:gettdb: "
+		    "linked entry in tdb table for hash=%d of SA:%s requested.\n",
+		    hashval,
+		    sa_len ? sa : " (error)");
 
 	if(!(tdbp = tdbh[hashval])) {
 		KLIPS_PRINT(debug_xform,
-			    "klips_debug:gettdb: no entries in tdb table for hash=%d of SA:%s.\n",
-			    hashval, sa);
+			    "klips_debug:gettdb: "
+			    "no entries in tdb table for hash=%d of SA:%s.\n",
+			    hashval,
+			    sa_len ? sa : " (error)");
 		return NULL;
 	}
 
@@ -132,12 +141,16 @@
 	}
 	
 	KLIPS_PRINT(debug_xform,
-		    "klips_debug:gettdb: no entry in linked list for hash=%d of SA:%s.\n",
-		    hashval, sa);
+		    "klips_debug:gettdb: "
+		    "no entry in linked list for hash=%d of SA:%s.\n",
+		    hashval,
+		    sa_len ? sa : " (error)");
 	return NULL;
 }
 
-/* void */
+/*
+  The tdb table better *NOT* be locked before it is handed in, or SMP locks will happen
+*/
 int
 puttdb(struct tdb *tdbp)
 {
@@ -146,7 +159,8 @@
 
 	if(!tdbp) {
 		KLIPS_PRINT(debug_xform,
-			    "klips_error:puttdb: null pointer passed in!\n");
+			    "klips_error:puttdb: "
+			    "null pointer passed in!\n");
 		return -ENODATA;
 	}
 	hashval = ((tdbp->tdb_said.spi + tdbp->tdb_said.dst.s_addr + tdbp->tdb_said.proto) % TDB_HASHMOD);
@@ -161,40 +175,46 @@
 	return error;
 }
 
-/* This tdb better be locked before it is handed in, or races might
- * happen */
-
-/* void */
+/*
+  The tdb table better be locked before it is handed in, or races might happen
+*/
 int
 deltdb(struct tdb *tdbp)
 {
 	unsigned int hashval;
 	struct tdb *tdbtp;
         char sa[SATOA_BUF];
+	size_t sa_len;
 
 	if(!tdbp) {
 		KLIPS_PRINT(debug_xform,
-			    "klips_error:deltdb: null pointer passed in!\n");
+			    "klips_error:deltdb: "
+			    "null pointer passed in!\n");
 		return -ENODATA;
 	}
 	
-	satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
+	sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
 	if(tdbp->tdb_inext || tdbp->tdb_onext) {
 		KLIPS_PRINT(debug_xform,
-			    "klips_error:deltdb: SA:%s still linked!\n",
-			    sa);
+			    "klips_error:deltdb: "
+			    "SA:%s still linked!\n",
+			    sa_len ? sa : " (error)");
 		return -EMLINK;
 	}
 	
 	hashval = ((tdbp->tdb_said.spi + tdbp->tdb_said.dst.s_addr + tdbp->tdb_said.proto) % TDB_HASHMOD);
 	
 	KLIPS_PRINT(debug_xform,
-		    "klips_debug:deltdb: deleting SA:%s, hashval=%d.\n",
-		    sa, hashval);
+		    "klips_debug:deltdb: "
+		    "deleting SA:%s, hashval=%d.\n",
+		    sa_len ? sa : " (error)",
+		    hashval);
 	if(!tdbh[hashval]) {
 		KLIPS_PRINT(debug_xform,
-			    "klips_debug:deltdb: no entries in tdb table for hash=%d of SA:%s.\n",
-			    hashval, sa);
+			    "klips_debug:deltdb: "
+			    "no entries in tdb table for hash=%d of SA:%s.\n",
+			    hashval,
+			    sa_len ? sa : " (error)");
 		return -ENOENT;
 	}
 	
@@ -202,7 +222,8 @@
 		tdbh[hashval] = tdbh[hashval]->tdb_hnext;
 		tdbp->tdb_hnext = NULL;
 		KLIPS_PRINT(debug_xform,
-			    "klips_debug:deltdb: successfully deleted first tdb in chain.\n");
+			    "klips_debug:deltdb: "
+			    "successfully deleted first tdb in chain.\n");
 		return 0;
 	} else {
 		for (tdbtp = tdbh[hashval]; tdbtp; tdbtp = tdbtp->tdb_hnext) {
@@ -210,53 +231,62 @@
 				tdbtp->tdb_hnext = tdbp->tdb_hnext;
 				tdbp->tdb_hnext = NULL;
 				KLIPS_PRINT(debug_xform,
-					    "klips_debug:deltdb: successfully "
-					    "deleted link in tdb chain.\n");
+					    "klips_debug:deltdb: "
+					    "successfully deleted link in tdb chain.\n");
 				return 0;
 			}
 		}
 	}
 	
 	KLIPS_PRINT(debug_xform,
-		    "klips_debug:deltdb: no entries in linked list for hash=%d of SA:%s.\n",
-		    hashval, sa);
+		    "klips_debug:deltdb: "
+		    "no entries in linked list for hash=%d of SA:%s.\n",
+		    hashval,
+		    sa_len ? sa : " (error)");
 	return -ENOENT;
 }
 
-/* This tdb better be locked before it is handed in, or races might
- * happen */
-
+/*
+  The tdb table better be locked before it is handed in, or races might happen
+*/
 int
 deltdbchain(struct tdb *tdbp)
 {
 	struct tdb *tdbdel;
 	int error = 0;
         char sa[SATOA_BUF];
+	size_t sa_len;
 
 	if(!tdbp) {
 		KLIPS_PRINT(debug_xform,
-			    "klips_error:deltdbchain: null pointer passed in!\n");
+			    "klips_error:deltdbchain: "
+			    "null pointer passed in!\n");
 		return -ENODATA;
 	}
 
-	satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
+	sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
 	KLIPS_PRINT(debug_xform,
-		    "klips_debug:deltdbchain: passed SA:%s\n", sa);
+		    "klips_debug:deltdbchain: "
+		    "passed SA:%s\n",
+		    sa_len ? sa : " (error)");
 	while(tdbp->tdb_onext) {
 		tdbp = tdbp->tdb_onext;
 	}
 
 	while(tdbp) {
 		/* XXX send a pfkey message up to advise of deleted TDB */
-		satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
+		sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
 		KLIPS_PRINT(debug_xform,
-			    "klips_debug:deltdbchain: unlinking and delting SA:%s", sa);
+			    "klips_debug:deltdbchain: "
+			    "unlinking and delting SA:%s",
+			    sa_len ? sa : " (error)");
 		tdbdel = tdbp;
 		tdbp = tdbp->tdb_inext;
 		if(tdbp) {
-			satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
+			sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
 			KLIPS_PRINT(debug_xform,
-				    ", inext=%s", sa);
+				    ", inext=%s",
+				    sa_len ? sa : " (error)");
 			tdbdel->tdb_inext = NULL;
 			tdbp->tdb_onext = NULL;
 		}
@@ -284,34 +314,39 @@
 {
 	int alg;
 	struct xformsw *xsp;
-	int len;
+	int error = 0;
         int i;
-#if defined(CONFIG_IPSEC_ENC_3DES)
+#if defined(CONFIG_IPSEC_ENC_DES) || defined(CONFIG_IPSEC_ENC_3DES)
         int error;
-#endif /* CONFIG_IPSEC_ENC_3DES */
+#endif /* CONFIG_IPSEC_ENC_{,3}DES */
 
         char sa[SATOA_BUF];
         size_t sa_len;
 
 	if(!tdbp || !em) {
 		KLIPS_PRINT(debug_xform,
-			    "klips_error:tdb_init: null pointer passed in!\n");
+			    "klips_error:tdb_init: "
+			    "null pointer passed in!\n");
 		SENDERR(ENODATA);
 	}
 
 	sa_len = satoa(em->em_said, 0, sa, SATOA_BUF);
 
         KLIPS_PRINT(debug_esp,
-		    "klips_debug:tdb_init: (algo_switch defined) called for SA:%s\n", sa);
+		    "klips_debug:tdb_init: "
+		    "(algo_switch defined) called for SA:%s\n",
+		    sa_len ? sa : " (error)");
 	alg = em->em_alg;
 	
 	for (xsp = xformsw; xsp < xformswNXFORMSW; xsp++) {
 		if (xsp->xf_type == alg) {
 			KLIPS_PRINT(debug_netlink,
-				    "klips_debug:tdb_init: called with tdbp=0x%p, xsp=0x%p, em=0x%p\n",
+				    "klips_debug:tdb_init: "
+				    "called with tdbp=0x%p, xsp=0x%p, em=0x%p\n",
 				    tdbp, xsp, em);
 			KLIPS_PRINT(debug_netlink,
-				    "klips_debug:tdb_init: calling init routine of %s\n",
+				    "klips_debug:tdb_init: "
+				    "calling init routine of %s\n",
 				    xsp->xf_name);
 			tdbp->tdb_xform = xsp;
 			tdbp->tdb_replaywin_lastseq = 0;
@@ -363,22 +398,23 @@
 				
 				if (ed->ame_klen != AHMD596_KLEN) {
 					KLIPS_PRINT(debug_ah,
-						    "klips_debug:tdb_init: incorrect key size: %d"
-						    "-- must be %d octets (bytes)\n",
+						    "klips_debug:tdb_init: "
+						    "incorrect key size: %d -- must be %d octets (bytes)\n",
 						    ed->ame_klen, AHMD596_KLEN);
 					SENDERR(EINVAL);
 				}
 				
 				if (ed->ame_alen != AHMD596_ALEN) {
 					KLIPS_PRINT(debug_ah,
-						    "klips_debug:tdb_init: authenticator size: %d"
-						    " -- must be %d octets (bytes)\n",
+						    "klips_debug:tdb_init: "
+						    "authenticator size: %d -- must be %d octets (bytes)\n",
 						    ed->ame_alen, AHMD596_ALEN);
 					SENDERR(EINVAL);
 				}
 				
 				KLIPS_PRINT(debug_ah,
-					    "klips_debug:tdb_init: hmac md5-96 key is 0x%08x %08x %08x %08x\n",
+					    "klips_debug:tdb_init: "
+					    "hmac md5-96 key is 0x%08x %08x %08x %08x\n",
 					    (__u32)ntohl(*(((__u32 *)ed->ame_key)+0)),
 					    (__u32)ntohl(*(((__u32 *)ed->ame_key)+1)),
 					    (__u32)ntohl(*(((__u32 *)ed->ame_key)+2)),
@@ -389,8 +425,8 @@
 				
 				if(ed->ame_ooowin > 64) {
 					KLIPS_PRINT(debug_ah,
-						    "klips_debug:tdb_init: replay window size: %d"
-						    " -- must be 0 <= size <= 64\n",
+						    "klips_debug:tdb_init: "
+						    "replay window size: %d -- must be 0 <= size <= 64\n",
 						    ed->ame_ooowin);
 					SENDERR(EINVAL);
 				}
@@ -422,8 +458,8 @@
 				MD5Update(octx, kb, AHMD596_BLKLEN);
 				
 				KLIPS_PRINT(debug_ah,
-					    "klips_debug:tdb_init: MD5 ictx=0x%08x %08x %08x %08x"
-					    " octx=0x%08x %08x %08x %08x\n",
+					    "klips_debug:tdb_init: "
+					    "MD5 ictx=0x%08x %08x %08x %08x octx=0x%08x %08x %08x %08x\n",
 					    ((__u32*)ictx)[0],
 					    ((__u32*)ictx)[1],
 					    ((__u32*)ictx)[2],
@@ -456,22 +492,23 @@
 				
 				if (ed->ame_klen != AHSHA196_KLEN) {
 					KLIPS_PRINT(debug_ah,
-						    "klips_debug:tdb_init: incorrect key size: %d"
-						    "-- must be %d octets (bytes)\n",
+						    "klips_debug:tdb_init: "
+						    "incorrect key size: %d -- must be %d octets (bytes)\n",
 						    ed->ame_klen, AHSHA196_KLEN);
 					SENDERR(EINVAL);
 				}
 				
 				if (ed->ame_alen != AHSHA196_ALEN) {
 					KLIPS_PRINT(debug_ah,
-						    "klips_debug:tdb_init: authenticator size: %d"
-						    " -- must be %d octets (bytes)\n",
+						    "klips_debug:tdb_init: "
+						    "authenticator size: %d -- must be %d octets (bytes)\n",
 						    ed->ame_alen, AHSHA196_ALEN);
 					SENDERR(EINVAL);
 				}
 				
 				KLIPS_PRINT(debug_ah,
-					    "klips_debug:tdb_init: hmac sha1-96 key is 0x%08x %08x %08x %08x\n",
+					    "klips_debug:tdb_init: "
+					    "hmac sha1-96 key is 0x%08x %08x %08x %08x\n",
 					    (__u32)ntohl(*(((__u32 *)ed->ame_key)+0)),
 					    (__u32)ntohl(*(((__u32 *)ed->ame_key)+1)),
 					    (__u32)ntohl(*(((__u32 *)ed->ame_key)+2)),
@@ -482,8 +519,8 @@
 				
 				if(ed->ame_ooowin > 64) {
 					KLIPS_PRINT(debug_ah,
-						    "klips_debug:tdb_init: replay window size: %d"
-						    " -- must be 0 <= size <= 64\n",
+						    "klips_debug:tdb_init: "
+						    "replay window size: %d -- must be 0 <= size <= 64\n",
 						    ed->ame_ooowin);
 					SENDERR(EINVAL);
 				}
@@ -513,8 +550,8 @@
 				SHA1Update(octx, kb, AHSHA196_BLKLEN);
 				
 				KLIPS_PRINT(debug_ah,
-					    "klips_debug:tdb_init: SHA1 ictx=0x%08x %08x %08x %08x"
-					    " octx=0x%08x %08x %08x %08x\n", 
+					    "klips_debug:tdb_init: "
+					    "SHA1 ictx=0x%08x %08x %08x %08x octx=0x%08x %08x %08x %08x\n", 
 					    ((__u32*)ictx)[0],
 					    ((__u32*)ictx)[1],
 					    ((__u32*)ictx)[2],
@@ -534,6 +571,16 @@
 #endif /* CONFIG_IPSEC_AH */
 
 #ifdef CONFIG_IPSEC_ESP
+#ifdef CONFIG_IPSEC_ENC_DES
+			case XF_ESPDES:
+#ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
+			case XF_ESPDESMD596:
+#endif /* CONFIG_IPSEC_AUTH_HMAC_MD5 */
+#ifdef CONFIG_IPSEC_AUTH_HMAC_SHA1
+			case XF_ESPDESSHA196:
+#endif /* CONFIG_IPSEC_AUTH_HMAC_SHA1 */
+#endif /* CONFIG_IPSEC_ENC_DES */
+
 #ifdef CONFIG_IPSEC_ENC_3DES
 			case XF_ESP3DES:
 #ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
@@ -543,14 +590,6 @@
 			case XF_ESP3DESSHA196:
 #endif /* CONFIG_IPSEC_AUTH_HMAC_SHA1 */
 #endif /* CONFIG_IPSEC_ENC_3DES */
-#ifdef CONFIG_IPSEC_ENC_NULL
-#ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
-			case XF_ESPNULLMD596:
-#endif /* CONFIG_IPSEC_AUTH_HMAC_MD5 */
-#ifdef CONFIG_IPSEC_AUTH_HMAC_SHA1
-			case XF_ESPNULLSHA196:
-#endif /* CONFIG_IPSEC_AUTH_HMAC_SHA1 */
-#endif /* CONFIG_IPSEC_ENC_NULL */
 			{
 				struct espblkrply_edata *ed;
 				unsigned char kb[AHMD596_BLKLEN];
@@ -570,8 +609,8 @@
 
 				if(ed->eme_ooowin > 64) {
 					KLIPS_PRINT(debug_esp,
-						    "klips_debug:tdb_init: replay window size: %d"
-						    "-- must be 0 <= size <= 64\n",
+						    "klips_debug:tdb_init: "
+						    "replay window size: %d -- must be 0 <= size <= 64\n",
 						    ed->eme_ooowin);
 					SENDERR(EINVAL);
 				}
@@ -581,6 +620,9 @@
 				case XF_ESP3DES:
 				case XF_ESP3DESMD596:
 				case XF_ESP3DESSHA196:
+				case XF_ESPDES:
+				case XF_ESPDESMD596:
+				case XF_ESPDESSHA196:
 					if((tdbp->tdb_iv = (caddr_t)
 					   kmalloc((tdbp->tdb_iv_size = EMT_ESPDES_IV_SZ), GFP_ATOMIC)) == NULL) {
 						SENDERR(ENOMEM);
@@ -592,6 +634,45 @@
 				}
 
 				switch(alg) {
+
+#ifdef CONFIG_IPSEC_ENC_DES
+				case XF_ESPDES:
+				case XF_ESPDESMD596:
+				case XF_ESPDESSHA196:
+					tdbp->tdb_encalg = ESP_DES;
+				
+					if (ed->eme_klen != EMT_ESPDES_KEY_SZ) {
+						KLIPS_PRINT(debug_esp,
+							    "klips_debug:tdb_init: "
+							    "incorrect encryption key size: %d -- must be %d octets (bytes)\n",
+							    ed->eme_klen, EMT_ESPDES_KEY_SZ);
+						SENDERR(EINVAL);
+					}
+
+					tdbp->tdb_key_bits_e = ed->eme_klen;
+
+					if((tdbp->tdb_key_e = (caddr_t)
+					   kmalloc((tdbp->tdb_key_e_size = sizeof(struct des_eks)),
+						   GFP_ATOMIC)) == NULL) {
+						SENDERR(ENOMEM);
+					}
+
+						error = des_set_key((caddr_t)(ed->eme_key),
+								    (caddr_t)&((struct des_eks*)(tdbp->tdb_key_e)));
+						if (error == -1)
+							printk("klips_debug:tdb_init: "
+							       "parity error in des key\n");
+						else if (error == -2)
+							printk("klips_debug:tdb_init: "
+							       "illegal weak des key\n");
+						if (error) {
+							memset(tdbp->tdb_key_e, 0, sizeof(struct des_eks));
+							kfree(tdbp->tdb_key_e);
+							SENDERR(EINVAL);
+						}
+
+					break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case XF_ESP3DES:
 				case XF_ESP3DESMD596:
@@ -600,8 +681,8 @@
 				
 					if (ed->eme_klen != EMT_ESP3DES_KEY_SZ) {
 						KLIPS_PRINT(debug_esp,
-							    "klips_debug:tdb_init: incorrect encryption "
-							    "key size: %d -- must be %d octets (bytes)\n",
+							    "klips_debug:tdb_init: "
+							    "incorrect encryption key size: %d -- must be %d octets (bytes)\n",
 							    ed->eme_klen, EMT_ESP3DES_KEY_SZ);
 						SENDERR(EINVAL);
 					}
@@ -617,7 +698,8 @@
 					for(i = 0; i < 3; i++) {
 #if 0
 						KLIPS_PRINT(debug_esp,
-							    "klips_debug:tdb_init: 3des key %d/3 is 0x%08lx%08lx\n",
+							    "klips_debug:tdb_init: "
+							    "3des key %d/3 is 0x%08lx%08lx\n",
 							    i + 1,
 							    ntohl(*((__u32 *)ed->eme_key + i * 2)),
 							    ntohl(*((__u32 *)ed->eme_key + i * 2 + 1)));
@@ -625,9 +707,11 @@
 						error = des_set_key((caddr_t)(ed->eme_key) + EMT_ESPDES_KEY_SZ * i,
 								    (caddr_t)&((struct des_eks*)(tdbp->tdb_key_e))[i]);
 						if (error == -1)
-							printk("klips_debug:tdb_init: parity error in des key %d/3\n", i + 1);
+							printk("klips_debug:tdb_init: "
+							       "parity error in des key %d/3\n", i + 1);
 						else if (error == -2)
-							printk("klips_debug:tdb_init: illegal weak des key %d/3\n", i + 1);
+							printk("klips_debug:tdb_init: "
+							       "illegal weak des key %d/3\n", i + 1);
 						if (error) {
 							memset(tdbp->tdb_key_e, 0, 3 * sizeof(struct des_eks));
 							kfree(tdbp->tdb_key_e);
@@ -643,6 +727,7 @@
 
 				switch(alg) {
 #ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
+				case XF_ESPDESMD596:
 				case XF_ESP3DESMD596:
 				case XF_ESPNULLMD596:
 				{
@@ -653,8 +738,8 @@
 				
 					if (ed->ame_klen != AHMD596_KLEN) {
 						KLIPS_PRINT(debug_esp,
-							    "klips_debug:tdb_init: incorrect authorisation "
-							    " key size: %d -- must be %d octets (bytes)\n",
+							    "klips_debug:tdb_init: "
+							    "incorrect authorisation  key size: %d -- must be %d octets (bytes)\n",
 							    ed->ame_klen, AHMD596_KLEN);
 						SENDERR(EINVAL);
 					}
@@ -669,7 +754,8 @@
 						SENDERR(ENOMEM);
 					}
 					KLIPS_PRINT(debug_esp,
-						    "klips_debug:tdb_init: hmac md5-96 key is 0x%08x %08x %08x %08x\n",
+						    "klips_debug:tdb_init: "
+						    "hmac md5-96 key is 0x%08x %08x %08x %08x\n",
 						    (__u32)ntohl(*(((__u32 *)ed->ame_key)+0)),
 						    (__u32)ntohl(*(((__u32 *)ed->ame_key)+1)),
 						    (__u32)ntohl(*(((__u32 *)ed->ame_key)+2)),
@@ -698,8 +784,8 @@
 					MD5Update(octx, kb, AHMD596_BLKLEN);
 					
 					KLIPS_PRINT(debug_esp,
-						    "klips_debug:tdb_init: MD5 ictx=0x%08x %08x %08x %08x"
-						    " octx=0x%08x %08x %08x %08x\n",
+						    "klips_debug:tdb_init: "
+						    "MD5 ictx=0x%08x %08x %08x %08x octx=0x%08x %08x %08x %08x\n",
 						    ((__u32*)ictx)[0],
 						    ((__u32*)ictx)[1],
 						    ((__u32*)ictx)[2],
@@ -717,6 +803,7 @@
 #endif /* CONFIG_IPSEC_AUTH_HMAC_MD5 */
 #ifdef CONFIG_IPSEC_AUTH_HMAC_SHA1
 				case XF_ESPNULLSHA196:
+				case XF_ESPDESSHA196:
 				case XF_ESP3DESSHA196:
 				{
 					SHA1_CTX *ictx;
@@ -726,8 +813,8 @@
 				
 					if (ed->ame_klen != AHSHA196_KLEN) {
 						KLIPS_PRINT(debug_esp,
-							    "klips_debug:tdb_init: incorrect authorisation "
-							    " key size: %d -- must be %d octets (bytes)\n",
+							    "klips_debug:tdb_init: "
+							    "incorrect authorisation key size: %d -- must be %d octets (bytes)\n",
 							    ed->ame_klen, AHSHA196_KLEN);
 						SENDERR(EINVAL);
 					}
@@ -741,7 +828,8 @@
 						SENDERR(ENOMEM);
 					}
 					KLIPS_PRINT(debug_esp,
-						    "klips_debug:tdb_init: hmac sha1-96 key is 0x%08x %08x %08x %08x\n",
+						    "klips_debug:tdb_init: "
+						    "hmac sha1-96 key is 0x%08x %08x %08x %08x\n",
 						    (__u32)ntohl(*(((__u32 *)ed->ame_key)+0)),
 						    (__u32)ntohl(*(((__u32 *)ed->ame_key)+1)),
 						    (__u32)ntohl(*(((__u32 *)ed->ame_key)+2)),
@@ -768,8 +856,8 @@
 					SHA1Update(octx, kb, AHSHA196_BLKLEN);
 				
 					KLIPS_PRINT(debug_esp,
-						    "klips_debug:tdb_init: SHA1 ictx=0x%08x %08x %08x %08x"
-						    " octx=0x%08x %08x %08x %08x\n",
+						    "klips_debug:tdb_init: "
+						    "SHA1 ictx=0x%08x %08x %08x %08x octx=0x%08x %08x %08x %08x\n",
 						    ((__u32*)ictx)[0],
 						    ((__u32*)ictx)[1],
 						    ((__u32*)ictx)[2],
@@ -785,6 +873,7 @@
 					break;
 				}
 #endif /* CONFIG_IPSEC_AUTH_HMAC_SHA1 */
+				case XF_ESPDES:
 				case XF_ESP3DES:
 					tdbp->tdb_authalg = AH_NONE;
 					break;
@@ -795,18 +884,22 @@
 #endif /* !CONFIG_IPSEC_ESP */
 			default:
 				KLIPS_PRINT(debug_xform,
-					    "klips_debug:tdb_init: alg=%d not configured\n", alg);
+					    "klips_debug:tdb_init: "
+					    "alg=%d not configured\n",
+					    alg);
 				SENDERR(ESOCKTNOSUPPORT);
 			}
 			SENDERR(0);
 		}
 	}
 	KLIPS_PRINT(debug_xform & DB_XF_INIT,
-		    "klips_debug:tdb_init: unregistered algorithm %d requested\n"
-		    "klips_debug:   trying to setup SA:%s\n", alg, sa);
+		    "klips_debug:tdb_init: "
+		    "unregistered algorithm %d requested trying to setup SA:%s\n",
+		    alg,
+		    sa_len ? sa : " (error)");
 	SENDERR(EINVAL);
 errlab:
-	return len;
+	return error;
 }
 #endif
 
@@ -817,9 +910,12 @@
 	int error = 0;
 	struct tdb *tdbp, **tdbprev, *tdbdel;
         char sa[SATOA_BUF];
+	size_t sa_len;
 
 	KLIPS_PRINT(debug_xform,
-		    "klips_debug:ipsec_tdbcleanup: cleaning up proto=%d.\n", proto);
+		    "klips_debug:ipsec_tdbcleanup: "
+		    "cleaning up proto=%d.\n",
+		    proto);
 
 	spin_lock_bh(&tdb_lock);
 
@@ -827,56 +923,67 @@
 		tdbprev = &(tdbh[i]);
 		tdbp = tdbh[i];
 		for(; tdbp;) {
-			satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
+			sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
 			KLIPS_PRINT(debug_xform,
-				    "klips_debug:ipsec_tdbcleanup: checking SA:%s, hash=%d",
-				    sa, i);
+				    "klips_debug:ipsec_tdbcleanup: "
+				    "checking SA:%s, hash=%d",
+				    sa_len ? sa : " (error)",
+				    i);
 			tdbdel = tdbp;
 			tdbp = tdbdel->tdb_hnext;
 			if(tdbp) {
-				satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
+				sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
 				KLIPS_PRINT(debug_xform,
-					    ", hnext=%s", sa);
+					    ", hnext=%s",
+					    sa_len ? sa : " (error)");
 			}
 			if(*tdbprev) {
-				satoa((*tdbprev)->tdb_said, 0, sa, SATOA_BUF);
+				sa_len = satoa((*tdbprev)->tdb_said, 0, sa, SATOA_BUF);
 				KLIPS_PRINT(debug_xform,
-					    ", *tdbprev=%s", sa);
+					    ", *tdbprev=%s",
+					    sa_len ? sa : " (error)");
 				if((*tdbprev)->tdb_hnext) {
-					satoa((*tdbprev)->tdb_hnext->tdb_said, 0, sa, SATOA_BUF);
+					sa_len = satoa((*tdbprev)->tdb_hnext->tdb_said, 0, sa, SATOA_BUF);
 					KLIPS_PRINT(debug_xform,
-						    ", *tdbprev->tdb_hnext=%s", sa);
+						    ", *tdbprev->tdb_hnext=%s",
+						    sa_len ? sa : " (error)");
 				}
 			}
 			KLIPS_PRINT(debug_xform,
 				    ".\n");
 			if(!proto || (proto == tdbdel->tdb_said.proto)) {
-				satoa(tdbdel->tdb_said, 0, sa, SATOA_BUF);
+				sa_len = satoa(tdbdel->tdb_said, 0, sa, SATOA_BUF);
 				KLIPS_PRINT(debug_xform,
-					    "klips_debug:ipsec_tdbcleanup: deleting SA chain:%s.\n",
-					    sa);
-				/* *tdbprev = tdbdel->tdb_hnext; */
+					    "klips_debug:ipsec_tdbcleanup: "
+					    "deleting SA chain:%s.\n",
+					    sa_len ? sa : " (error)");
 				if((error = deltdbchain(tdbdel))) {
-					goto errlab;
+					SENDERR(-error);
 				}
 				tdbprev = &(tdbh[i]);
 				tdbp = tdbh[i];
 
 				KLIPS_PRINT(debug_xform,
-					    "klips_debug:ipsec_tdbcleanup: deleted SA chain:%s", sa);
+					    "klips_debug:ipsec_tdbcleanup: "
+					    "deleted SA chain:%s",
+					    sa_len ? sa : " (error)");
 				if(tdbp) {
-					satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
+					sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
 					KLIPS_PRINT(debug_xform,
-						    ", tdbh[%d]=%s", i, sa);
+						    ", tdbh[%d]=%s",
+						    i,
+						    sa_len ? sa : " (error)");
 				}
 				if(*tdbprev) {
-					satoa((*tdbprev)->tdb_said, 0, sa, SATOA_BUF);
+					sa_len = satoa((*tdbprev)->tdb_said, 0, sa, SATOA_BUF);
 					KLIPS_PRINT(debug_xform,
-						    ", *tdbprev=%s", sa);
+						    ", *tdbprev=%s",
+						    sa_len ? sa : " (error)");
 					if((*tdbprev)->tdb_hnext) {
-						satoa((*tdbprev)->tdb_hnext->tdb_said, 0, sa, SATOA_BUF);
+						sa_len = satoa((*tdbprev)->tdb_hnext->tdb_said, 0, sa, SATOA_BUF);
 						KLIPS_PRINT(debug_xform,
-							    ", *tdbprev->tdb_hnext=%s", sa);
+							    ", *tdbprev->tdb_hnext=%s",
+							    sa_len ? sa : " (error)");
 					}
 				}
 				KLIPS_PRINT(debug_xform,
@@ -890,14 +997,14 @@
 
 	spin_unlock_bh(&tdb_lock);
 
-	return(-error);
+	return(error);
 }
 
 int
 ipsec_tdbwipe(struct tdb *tdbp)
 {
 	if(!tdbp) {
-		return -1;
+		return -ENODATA;
 	}
 
 	if(tdbp->tdb_addr_s) {
@@ -961,6 +1068,22 @@
 
 /*
  * $Log: ipsec_xform.c,v $
+ * Revision 1.51  2001/05/30 08:14:03  rgb
+ * Removed vestiges of esp-null transforms.
+ *
+ * Revision 1.50  2001/05/03 19:43:18  rgb
+ * Initialise error return variable.
+ * Update SENDERR macro.
+ * Fix sign of error return code for ipsec_tdbcleanup().
+ * Use more appropriate return code for ipsec_tdbwipe().
+ *
+ * Revision 1.49  2001/04/19 18:56:17  rgb
+ * Fixed tdb table locking comments.
+ *
+ * Revision 1.48  2001/02/27 22:24:55  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
  * Revision 1.47  2000/11/06 04:32:08  rgb
  * Ditched spin_lock_irqsave in favour of spin_lock_bh.
  *
@@ -976,9 +1099,6 @@
  *
  * Revision 1.43  2000/08/18 21:30:41  rgb
  * Purged all tdb_spi, tdb_proto and tdb_dst macros.  They are unclear.
- *
- * Revision 1.42  2000/08/01 14:51:51  rgb
- * Removed _all_ remaining traces of DES.
  *
  * Revision 1.41  2000/07/28 14:58:31  rgb
  * Changed kfree_s to kfree, eliminating extra arg to fix 2.4.0-test5.
